diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index 89ae995..7320316 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -3346,27 +2598,14 @@ _cl5DoPurging(cleanruv_purge_data *purge_data)
 {
     ReplicaId rid = purge_data->cleaned_rid;
     const Slapi_DN *suffix_sdn = purge_data->suffix_sdn;
-    const char *replName = purge_data->replName;
-    char *replGen = purge_data->replGen;
-    char *fileName;
-    Object *obj;
+    cldb_Handle *cldb = replica_get_file_info(purge_data->replica);
 
-    PR_Lock(s_cl5Desc.dbTrim.lock);
-    fileName = _cl5MakeFileName(replName, replGen);
-    obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (obj) {
-        /* We found our changelog, now purge it */
-        _cl5PurgeRID(obj, rid);
-        object_release(obj);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DoPurging - Purged rid (%d) from suffix (%s)\n",
-                      rid, slapi_sdn_get_dn(suffix_sdn));
-    } else {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5DoPurging - Purge rid (%d) failed to find changelog file (%s) for suffix (%s)\n",
-                      rid, fileName, slapi_sdn_get_dn(suffix_sdn));
-    }
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
+    PR_Lock (s_cl5Desc.dbTrim.lock);
+    _cl5PurgeRID (cldb, rid);
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                  "_cl5DoPurging - Purged rid (%d) from suffix (%s)\n",
+                  rid, slapi_sdn_get_dn(suffix_sdn));
+    PR_Unlock (s_cl5Desc.dbTrim.lock);
 
     return;
 }
@@ -3375,63 +2614,57 @@ _cl5DoPurging(cleanruv_purge_data *purge_data)
 static void
 _cl5CompactDBs(void)
 {
+    replica_enumerate_replicas(_cl5CompactOneDB, NULL);
+    return;
+}
+static int
+_cl5CompactOneDB(Replica *r, void *arg)
+{
     int rc;
-    Object *fileObj = NULL;
-    CL5DBFile *dbFile = NULL;
     DB *db = NULL;
     DB_TXN *txnid = NULL;
     DB_COMPACT c_data = {0};
+    cldb_Handle *cldb = replica_get_file_info(r);
 
-    PR_Lock(s_cl5Desc.dbTrim.lock);
+    PR_Lock (s_cl5Desc.dbTrim.lock);
     rc = TXN_BEGIN(s_cl5Desc.dbEnv, NULL, &txnid, 0);
     if (rc) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, 
                       "_cl5CompactDBs - Failed to begin transaction; db error - %d %s\n",
                       rc, db_strerror(rc));
         goto bail;
     }
-    for (fileObj = objset_first_obj(s_cl5Desc.dbFiles);
-         fileObj;
-         fileObj = objset_next_obj(s_cl5Desc.dbFiles, fileObj)) {
-        dbFile = (CL5DBFile *)object_get_data(fileObj);
-        if (!dbFile) {
-            continue;
-        }
-        db = dbFile->db;
-        rc = db->compact(db, txnid, NULL /*start*/, NULL /*stop*/,
-                         &c_data, DB_FREE_SPACE, NULL /*end*/);
-        if (rc) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CompactDBs - Failed to compact %s; db error - %d %s\n",
-                          dbFile->replName, rc, db_strerror(rc));
-            goto bail;
-        }
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5CompactDBs - %s - %d pages freed\n",
-                      dbFile->replName, c_data.compact_pages_free);
-    }
-bail:
-    if (fileObj) {
-        object_release(fileObj);
+    db = cldb->db;
+    rc = db->compact(db, txnid, NULL/*start*/, NULL/*stop*/,
+                     &c_data, DB_FREE_SPACE, NULL/*end*/);
+
+    if (rc) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, 
+                      "_cl5CompactDBs - Failed to compact %s; db error - %d %s\n",
+                      cldb->ident, rc, db_strerror(rc));
+        goto bail;
     }
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                  "_cl5CompactDBs - %s - %d pages freed\n",
+                   cldb->ident, c_data.compact_pages_free);
+bail:   
     if (rc) {
-        rc = TXN_ABORT(txnid);
+        rc = TXN_ABORT (txnid);
         if (rc) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, 
                           "_cl5CompactDBs - Failed to abort transaction; db error - %d %s\n",
                           rc, db_strerror(rc));
         }
     } else {
-        rc = TXN_COMMIT(txnid);
+        rc = TXN_COMMIT (txnid);
         if (rc) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5CompactDBs - Failed to commit transaction; db error - %d %s\n",
                           rc, db_strerror(rc));
         }
     }
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
-
-    return;
+    PR_Unlock (s_cl5Desc.dbTrim.lock);
+    return rc;
 }
 
 /*
@@ -3440,18 +2673,15 @@ bail:
  * starting point.
  */
 static int
-_cl5PurgeGetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key)
+_cl5PurgeGetFirstEntry(cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key)
 {
     DBC *cursor = NULL;
     DBT data = {0};
     CL5Iterator *it;
-    CL5DBFile *file;
     int rc;
 
-    file = (CL5DBFile *)object_get_data(obj);
-
     /* create cursor */
-    rc = file->db->cursor(file->db, txnid, &cursor, 0);
+    rc = cldb->db->cursor(cldb->db, txnid, &cursor, 0);
     if (rc != 0) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5PurgeGetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
@@ -3480,8 +2710,9 @@ _cl5PurgeGetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *tx
 
         it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
         it->cursor = cursor;
-        object_acquire(obj);
-        it->file = obj;
+        /* TBD do we need to lock the file in the iterator ?? */
+        /* object_acquire (obj); */
+        it->file = cldb;
         *(CL5Iterator **)iterator = it;
 
         return CL5_SUCCESS;
@@ -3583,7 +2814,7 @@ _cl5PurgeGetNextEntry(CL5Entry *entry, void *iterator, DBT *key)
  *  beginning for each new iteration.
  */
 static void
-_cl5PurgeRID(Object *obj, ReplicaId cleaned_rid)
+_cl5PurgeRID(cldb_Handle *cldb,  ReplicaId cleaned_rid)
 {
     slapi_operation_parameters op = {0};
     ReplicaId csn_rid;
@@ -3600,7 +2831,6 @@ _cl5PurgeRID(Object *obj, ReplicaId cleaned_rid)
     int finished = 0;
     int rc = 0;
 
-    PR_ASSERT(obj);
     entry.op = &op;
 
     /*
@@ -3628,7 +2858,7 @@ _cl5PurgeRID(Object *obj, ReplicaId cleaned_rid)
         /*
          * Check every changelog entry for the cleaned rid
          */
-        rc = _cl5PurgeGetFirstEntry(obj, &entry, &iterator, txnid, first_pass ? 0 : cleaned_rid, &key);
+        rc = _cl5PurgeGetFirstEntry(cldb, &entry, &iterator, txnid, first_pass?0:cleaned_rid, &key);
         first_pass = 0;
         while (rc == CL5_SUCCESS && !slapi_is_shutting_down()) {
             /*
@@ -3770,7 +3000,7 @@ _cl5PurgeRID(Object *obj, ReplicaId cleaned_rid)
 #define CL5_TRIM_MAX_PER_TRANSACTION 10
 
 static void
-_cl5TrimFile(Object *obj, long *numToTrim)
+_cl5TrimFile (Replica *r, long *numToTrim)
 {
     DB_TXN *txnid;
     RUV *ruv = NULL;
@@ -3783,10 +3013,10 @@ _cl5TrimFile(Object *obj, long *numToTrim)
     char strCSN[CSN_STRSIZE];
     int rc;
 
-    PR_ASSERT(obj);
+    cldb_Handle *cldb = replica_get_file_info(r);
 
     /* construct the ruv up to which we can purge */
-    rc = _cl5GetRUV2Purge2(obj, &ruv);
+    rc = _cl5GetRUV2Purge2(r, &ruv);
     if (rc != CL5_SUCCESS || ruv == NULL) {
         return;
     }
@@ -3809,7 +3039,7 @@ _cl5TrimFile(Object *obj, long *numToTrim)
             break;
         }
 
-        finished = _cl5GetFirstEntry(obj, &entry, &it, txnid);
+        finished = _cl5GetFirstEntry(cldb, &entry, &it, txnid);
         while (!finished && !slapi_is_shutting_down()) {
             /*
              * This change can be trimmed if it exceeds purge
@@ -3824,11 +3054,11 @@ _cl5TrimFile(Object *obj, long *numToTrim)
             }
             csn_rid = csn_get_replicaid(op.csn);
 
-            if ((*numToTrim > 0 || _cl5CanTrim(entry.time, numToTrim)) &&
+            if ((*numToTrim > 0 || _cl5CanTrim(entry.time, numToTrim, r)) &&
                 ruv_covers_csn_strict(ruv, op.csn)) {
                 rc = _cl5CurrentDeleteEntry(it);
                 if (rc == CL5_SUCCESS) {
-                    rc = _cl5UpdateRUV(obj, op.csn, PR_FALSE, PR_TRUE);
+                    rc = _cl5UpdateRUV(cldb, op.csn, PR_FALSE, PR_TRUE);
                 }
                 if (rc == CL5_SUCCESS) {
                     if (*numToTrim > 0)
@@ -3915,7 +3145,7 @@ _cl5TrimFile(Object *obj, long *numToTrim)
 }
 
 static PRBool
-_cl5CanTrim(time_t time, long *numToTrim)
+_cl5CanTrim(time_t time, long *numToTrim, Replica *replica)
 {
     *numToTrim = 0;
 
@@ -3923,12 +3153,12 @@ _cl5CanTrim(time_t time, long *numToTrim)
         return PR_FALSE;
     }
     if (s_cl5Desc.dbTrim.maxAge == 0) {
-        *numToTrim = cl5GetOperationCount(NULL) - s_cl5Desc.dbTrim.maxEntries;
+        *numToTrim = cl5GetOperationCount(replica) - s_cl5Desc.dbTrim.maxEntries;
         return (*numToTrim > 0);
     }
 
     if (s_cl5Desc.dbTrim.maxEntries > 0 &&
-        (*numToTrim = cl5GetOperationCount(NULL) - s_cl5Desc.dbTrim.maxEntries) > 0) {
+        (*numToTrim = cl5GetOperationCount(replica) - s_cl5Desc.dbTrim.maxEntries) > 0) {
         return PR_TRUE;
     }
 
@@ -3940,22 +3170,14 @@ _cl5CanTrim(time_t time, long *numToTrim)
 }
 
 static int
-_cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
+_cl5ReadRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     char csnStr[CSN_STRSIZE];
     DBT key = {0}, data = {0};
     struct berval **vals = NULL;
-    CL5DBFile *file;
     char *pos;
-    char *agmt_name;
-
-    PR_ASSERT(replGen && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-
-    agmt_name = get_thread_private_agmtname();
+    char *agmt_name = get_thread_private_agmtname();
 
     if (purge) { /* read purge vector entry */
         key.data = _cl5GetHelperEntryKey(PURGE_RUV_TIME, csnStr);
@@ -3965,7 +3187,7 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
     key.size = CSN_STRSIZE;
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
     switch (rc) {
     case 0:
         pos = data.data;
@@ -3975,9 +3197,9 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
             goto done;
 
         if (purge) {
-            rc = ruv_init_from_bervals(vals, &file->purgeRUV);
+            rc = ruv_init_from_bervals(vals, &cldb->purgeRUV);
         } else {
-            rc = ruv_init_from_bervals(vals, &file->maxRUV);
+            rc = ruv_init_from_bervals(vals, &cldb->maxRUV);
         }
         if (rc != RUV_SUCCESS) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
@@ -3991,13 +3213,13 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
 
         /* delete the entry; it is re-added when file
                                is successfully closed */
-        file->db->del(file->db, NULL, &key, 0);
+        cldb->db->del(cldb->db, NULL, &key, 0);
 
         rc = CL5_SUCCESS;
         goto done;
 
     case DB_NOTFOUND: /* RUV is lost - need to construct */
-        rc = _cl5ConstructRUV(replGen, obj, purge);
+        rc = _cl5ConstructRUV(cldb, purge);
         goto done;
 
     default:
@@ -4015,7 +3237,7 @@ done:
 }
 
 static int
-_cl5WriteRUV(CL5DBFile *file, PRBool purge)
+_cl5WriteRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     DBT key = {0}, data = {0};
@@ -4024,7 +3246,7 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
     DB_TXN *txnid = NULL;
     char *buff;
 
-    if ((purge && file->purgeRUV == NULL) || (!purge && file->maxRUV == NULL))
+    if ((purge && cldb->purgeRUV == NULL) || (!purge && cldb->maxRUV == NULL))
         return CL5_SUCCESS;
 
     if (purge) {
@@ -4034,18 +3256,18 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
          * matter, but it needs to be set to something so that it can be
          * flushed to changelog at shutdown and parsed at startup with the
          * regular string-to-RUV parsing routines. */
-        ruv_insert_dummy_min_csn(file->purgeRUV);
+        ruv_insert_dummy_min_csn(cldb->purgeRUV);
         key.data = _cl5GetHelperEntryKey(PURGE_RUV_TIME, csnStr);
-        rc = ruv_to_bervals(file->purgeRUV, &vals);
+        rc = ruv_to_bervals(cldb->purgeRUV, &vals);
     } else {
         key.data = _cl5GetHelperEntryKey(MAX_RUV_TIME, csnStr);
-        rc = ruv_to_bervals(file->maxRUV, &vals);
+        rc = ruv_to_bervals(cldb->maxRUV, &vals);
     }
 
-    if (!purge && _cl5CheckMaxRUV(file, file->maxRUV)) {
+    if (!purge && _cl5CheckMaxRUV(cldb, cldb->maxRUV)) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteRUV - changelog maxRUV not found in changelog for file %s\n",
-                      file->name);
+                      cldb->ident);
         ber_bvecfree(vals);
         return CL5_DB_ERROR;
     }
@@ -4059,7 +3281,7 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
         return rc;
     }
 
-    rc = file->db->put(file->db, txnid, &key, &data, 0);
+    rc = cldb->db->put(cldb->db, txnid, &key, &data, 0);
 
     slapi_ch_free(&(data.data));
     if (rc == 0) {
@@ -4067,7 +3289,7 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteRUV - Failed to write %s RUV for file %s; db error - %d (%s)\n",
-                      purge ? "purge" : "upper bound", file->name, rc, db_strerror(rc));
+                      purge ? "purge" : "upper bound", cldb->ident, rc, db_strerror(rc));
 
         if (CL5_OS_ERR_IS_DISKFULL(rc)) {
             cl5_set_diskfull();
@@ -4080,29 +3302,23 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
 /* This is a very slow process since we have to read every changelog entry.
    Hopefully, this function is not called too often */
 static int
-_cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
+_cl5ConstructRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     CL5Entry entry;
     void *iterator = NULL;
     slapi_operation_parameters op = {0};
-    CL5DBFile *file;
     ReplicaId rid;
 
-    PR_ASSERT(replGen && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-
     /* construct the RUV */
     if (purge)
-        rc = ruv_init_new(replGen, 0, NULL, &file->purgeRUV);
+        rc = ruv_init_new(cldb->ident, 0, NULL, &cldb->purgeRUV);
     else
-        rc = ruv_init_new(replGen, 0, NULL, &file->maxRUV);
+        rc = ruv_init_new(cldb->ident, 0, NULL, &cldb->maxRUV);
     if (rc != RUV_SUCCESS) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5ConstructRUV - "
                                                            "Failed to initialize %s RUV for file %s; ruv error - %d\n",
-                      purge ? "purge" : "upper bound", file->name, rc);
+                      purge ? "purge" : "upper bound", cldb->ident, rc);
         return CL5_RUV_ERROR;
     }
 
@@ -4111,7 +3327,7 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
                   "this may take several minutes...\n");
 
     entry.op = &op;
-    rc = _cl5GetFirstEntry(obj, &entry, &iterator, NULL);
+    rc = _cl5GetFirstEntry(cldb, &entry, &iterator, NULL);
     while (rc == CL5_SUCCESS) {
         if (op.csn) {
             rid = csn_get_replicaid(op.csn);
@@ -4132,15 +3348,15 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
             continue;
         }
         if (purge)
-            rc = ruv_set_csns_keep_smallest(file->purgeRUV, op.csn);
+            rc = ruv_set_csns_keep_smallest(cldb->purgeRUV, op.csn);
         else
-            rc = ruv_set_csns(file->maxRUV, op.csn, NULL);
+            rc = ruv_set_csns(cldb->maxRUV, op.csn, NULL);
 
         cl5_operation_parameters_done(&op);
         if (rc != RUV_SUCCESS) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5ConstructRUV - "
                                                                "Failed to update %s RUV for file %s; ruv error - %d\n",
-                          purge ? "purge" : "upper bound", file->name, rc);
+                          purge ? "purge" : "upper bound", cldb->ident, rc);
             rc = CL5_RUV_ERROR;
             continue;
         }
@@ -4157,9 +3373,9 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
         rc = CL5_SUCCESS;
     } else {
         if (purge)
-            ruv_destroy(&file->purgeRUV);
+            ruv_destroy(&cldb->purgeRUV);
         else
-            ruv_destroy(&file->maxRUV);
+            ruv_destroy(&cldb->maxRUV);
     }
 
     slapi_log_err(SLAPI_LOG_NOTICE, repl_plugin_name_cl,
@@ -4170,43 +3386,38 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
 }
 
 static int
-_cl5UpdateRUV(Object *obj, CSN *csn, PRBool newReplica, PRBool purge)
+_cl5UpdateRUV (cldb_Handle *cldb, CSN *csn, PRBool newReplica, PRBool purge)
 {
     ReplicaId rid;
     int rc = RUV_SUCCESS; /* initialize rc to avoid erroneous logs */
-    CL5DBFile *file;
-
-    PR_ASSERT(obj && csn);
-
-    file = (CL5DBFile *)object_get_data(obj);
 
     /*
-     *  if purge is TRUE, file->purgeRUV must be set;
+     *  if purge is TRUE, cldb->purgeRUV must be set;
      *  if purge is FALSE, maxRUV must be set
      */
-    PR_ASSERT(file && ((purge && file->purgeRUV) || (!purge && file->maxRUV)));
+    PR_ASSERT(cldb && ((purge && cldb->purgeRUV) || (!purge && cldb->maxRUV)));
     rid = csn_get_replicaid(csn);
 
     /* update vector only if this replica is not yet part of RUV */
     if (purge && newReplica) {
-        if (ruv_contains_replica(file->purgeRUV, rid)) {
+        if (ruv_contains_replica(cldb->purgeRUV, rid)) {
             return CL5_SUCCESS;
         } else {
             /* if the replica is not part of the purgeRUV yet, add it unless it's from a cleaned rid */
-            ruv_add_replica(file->purgeRUV, rid, multimaster_get_local_purl());
+            ruv_add_replica(cldb->purgeRUV, rid, multimaster_get_local_purl());
         }
     } else {
         if (purge) {
-            rc = ruv_set_csns(file->purgeRUV, csn, NULL);
+            rc = ruv_set_csns(cldb->purgeRUV, csn, NULL);
         } else {
-            rc = ruv_set_csns(file->maxRUV, csn, NULL);
+            rc = ruv_set_csns(cldb->maxRUV, csn, NULL);
         }
     }
 
     if (rc != RUV_SUCCESS) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5UpdatePurgeRUV - "
                                                            "Failed to update %s RUV for file %s; ruv error - %d\n",
-                      purge ? "purge" : "upper bound", file->name, rc);
+                      purge ? "purge" : "upper bound", cldb->ident, rc);
         return CL5_RUV_ERROR;
     }
 
@@ -4236,49 +3447,30 @@ _cl5EnumConsumerRUV(const ruv_enum_data *element, void *arg)
 }
 
 static int
-_cl5GetRUV2Purge2(Object *fileObj, RUV **ruv)
+_cl5GetRUV2Purge2 (Replica *r, RUV **ruv)
 {
     int rc = CL5_SUCCESS;
-    CL5DBFile *dbFile;
-    Object *rObj = NULL;
-    Replica *r = NULL;
     Object *agmtObj = NULL;
     Repl_Agmt *agmt;
     Object *consRUVObj, *supRUVObj;
     RUV *consRUV, *supRUV;
     CSN *csn;
 
-    PR_ASSERT(fileObj && ruv);
-
     if (!ruv) {
         rc = CL5_UNKNOWN_ERROR;
         goto done;
     }
 
-    dbFile = (CL5DBFile *)object_get_data(fileObj);
-    PR_ASSERT(dbFile);
-
-    rObj = replica_get_by_name(dbFile->replName);
-    PR_ASSERT(rObj);
-
-    if (!rObj) {
-        rc = CL5_NOTFOUND;
-        goto done;
-    }
-
-    r = (Replica *)object_get_data(rObj);
-    PR_ASSERT(r);
-
     /* We start with this replica's RUV. See note in _cl5DoTrimming */
-    supRUVObj = replica_get_ruv(r);
-    PR_ASSERT(supRUVObj);
+    supRUVObj = replica_get_ruv (r);
+    PR_ASSERT (supRUVObj);
 
-    supRUV = (RUV *)object_get_data(supRUVObj);
-    PR_ASSERT(supRUV);
+    supRUV = (RUV*)object_get_data (supRUVObj);
+    PR_ASSERT (supRUV);
 
-    *ruv = ruv_dup(supRUV);
+    *ruv = ruv_dup (supRUV);
 
-    object_release(supRUVObj);
+    object_release (supRUVObj);
 
     agmtObj = agmtlist_get_first_agreement_for_replica(r);
     while (agmtObj) {
@@ -4297,43 +3489,40 @@ _cl5GetRUV2Purge2(Object *fileObj, RUV **ruv)
                                                                    "Failed to construct ruv; ruv error - %d\n",
                               rc);
                 rc = CL5_RUV_ERROR;
-                object_release(consRUVObj);
-                object_release(agmtObj);
+                object_release (consRUVObj);
+                object_release (agmtObj);
                 break;
             }
 
-            object_release(consRUVObj);
+            object_release (consRUVObj);
         }
 
-        agmtObj = agmtlist_get_next_agreement_for_replica(r, agmtObj);
+        agmtObj = agmtlist_get_next_agreement_for_replica (r, agmtObj);
     }
 
     /* check if there is any data in the constructed ruv - otherwise get rid of it */
     if (ruv_get_max_csn(*ruv, &csn) != RUV_SUCCESS || csn == NULL) {
-        ruv_destroy(ruv);
-    } else {
-        csn_free(&csn);
+        ruv_destroy (ruv);
+    }
+    else {
+        csn_free (&csn);
     }
-done:
-    if (rObj)
-        object_release(rObj);
 
+done:
     if (rc != CL5_SUCCESS && ruv)
-        ruv_destroy(ruv);
+        ruv_destroy (ruv);
 
     return rc;
 }
 
 static int
-_cl5GetEntryCount(CL5DBFile *file)
+_cl5GetEntryCount (cldb_Handle *cldb)
 {
     int rc;
     char csnStr[CSN_STRSIZE];
     DBT key = {0}, data = {0};
     DB_BTREE_STAT *stats = NULL;
 
-    PR_ASSERT(file);
-
     /* read entry count. if the entry is there - the file was successfully closed
        last time it was used */
     key.data = _cl5GetHelperEntryKey(ENTRY_COUNT_TIME, csnStr);
@@ -4341,24 +3530,24 @@ _cl5GetEntryCount(CL5DBFile *file)
 
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
     switch (rc) {
     case 0:
-        file->entryCount = *(int *)data.data;
+        cldb->entryCount = *(int *)data.data;
         slapi_ch_free(&(data.data));
 
-        /* delete the entry. the entry is re-added when file
+        /* delete the entry. the entry is re-added when cldb
                                is successfully closed */
-        file->db->del(file->db, NULL, &key, 0);
+        cldb->db->del(cldb->db, NULL, &key, 0);
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5GetEntryCount - %d changes for replica %s\n",
-                      file->entryCount, file->replName);
+                      cldb->entryCount, cldb->ident);
         return CL5_SUCCESS;
 
     case DB_NOTFOUND:
-        file->entryCount = 0;
+        cldb->entryCount = 0;
 
-        rc = file->db->stat(file->db, NULL, (void *)&stats, 0);
+        rc = cldb->db->stat(cldb->db, NULL, (void *)&stats, 0);
         if (rc != 0) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5GetEntryCount - Failed to get changelog statistics; "
@@ -4368,13 +3557,13 @@ _cl5GetEntryCount(CL5DBFile *file)
         }
 
 #ifdef DB30
-        file->entryCount = stats->bt_nrecs;
+        cldb->entryCount = stats->bt_nrecs;
 #else /* DB31 */
-        file->entryCount = stats->bt_ndata;
+        cldb->entryCount = stats->bt_ndata;
 #endif
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5GetEntryCount - %d changes for replica %s\n",
-                      file->entryCount, file->replName);
+                      cldb->entryCount, cldb->ident);
 
         slapi_ch_free((void **)&stats);
         return CL5_SUCCESS;
@@ -4389,7 +3578,7 @@ _cl5GetEntryCount(CL5DBFile *file)
 }
 
 static int
-_cl5WriteEntryCount(CL5DBFile *file)
+_cl5WriteEntryCount (cldb_Handle *cldb)
 {
     int rc;
     DBT key = {0}, data = {0};
@@ -4398,17 +3587,17 @@ _cl5WriteEntryCount(CL5DBFile *file)
 
     key.data = _cl5GetHelperEntryKey(ENTRY_COUNT_TIME, csnStr);
     key.size = CSN_STRSIZE;
-    data.data = (void *)&file->entryCount;
-    data.size = sizeof(file->entryCount);
+    data.data = (void *)&cldb->entryCount;
+    data.size = sizeof(cldb->entryCount);
 
-    rc = file->db->put(file->db, txnid, &key, &data, 0);
+    rc = cldb->db->put(cldb->db, txnid, &key, &data, 0);
     if (rc == 0) {
         return CL5_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteEntryCount - "
                       "Failed to write count entry for file %s; db error - %d %s\n",
-                      file->name, rc, db_strerror(rc));
+                      cldb->ident, rc, db_strerror(rc));
         if (CL5_OS_ERR_IS_DISKFULL(rc)) {
             cl5_set_diskfull();
             return CL5_DB_ERROR;
@@ -4739,7 +3928,7 @@ _cl5LDIF2Operation(char *ldifEntry, slapi_operation_parameters *op, char **replG
 }
 
 static int
-_cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local __attribute__((unused)), void *txn)
+_cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local __attribute__((unused)), void *txn)
 {
     int rc;
     int cnt;
@@ -4748,27 +3937,9 @@ _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_ope
     char csnStr[CSN_STRSIZE];
     PRIntervalTime interval;
     CL5Entry entry;
-    CL5DBFile *file = NULL;
-    Object *file_obj = NULL;
     DB_TXN *txnid = NULL;
     DB_TXN *parent_txnid = (DB_TXN *)txn;
 
-    rc = _cl5GetDBFileByReplicaName(replName, replGen, &file_obj);
-    if (rc == CL5_NOTFOUND) {
-        rc = _cl5DBOpenFileByReplicaName(replName, replGen, &file_obj,
-                                         PR_TRUE /* check for duplicates */);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Failed to find or open DB object for replica %s\n", replName);
-            return rc;
-        }
-    } else if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteOperationTxn - Failed to get db file for target dn (%s)",
-                      REPL_GET_DN(&op->target_address));
-        return CL5_OBJSET_ERROR;
-    }
-
     /* assign entry time - used for trimming */
     entry.time = slapi_current_utc_time();
     entry.op = (slapi_operation_parameters *)op;
@@ -4789,12 +3960,9 @@ _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_ope
         goto done;
     }
 
-    file = (CL5DBFile *)object_get_data(file_obj);
-    PR_ASSERT(file);
-
     /* if this is part of ldif2cl - just write the entry without transaction */
     if (s_cl5Desc.dbOpenMode == CL5_OPEN_LDIF2CL) {
-        rc = file->db->put(file->db, NULL, &key, data, 0);
+        rc = cldb->db->put(cldb->db, NULL, &key, data, 0);
         if (rc != 0) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5WriteOperationTxn - Failed to write entry; db error - %d %s\n",
@@ -4836,7 +4004,7 @@ _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_ope
             goto done;
         }
 
-        rc = file->db->put(file->db, txnid, &key, data, 0);
+        rc = cldb->db->put(cldb->db, txnid, &key, data, 0);
         if (CL5_OS_ERR_IS_DISKFULL(rc)) {
             slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name_cl,
                           "_cl5WriteOperationTxn - Changelog (%s) DISK FULL; db error - %d %s\n",
@@ -4880,10 +4048,10 @@ _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_ope
     }
 
     /* update entry count - we assume that all entries are new */
-    PR_AtomicIncrement(&file->entryCount);
+    PR_AtomicIncrement(&cldb->entryCount);
 
     /* update purge vector if we have not seen any changes from this replica before */
-    _cl5UpdateRUV(file_obj, op->csn, PR_TRUE, PR_TRUE);
+    _cl5UpdateRUV(cldb, op->csn, PR_TRUE, PR_TRUE);
 
     slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                   "cl5WriteOperationTxn - Successfully written entry with csn (%s)\n", csnStr);
@@ -4893,33 +4061,28 @@ done:
         slapi_ch_free(&(data->data));
     slapi_ch_free((void **)&data);
 
-    if (file_obj)
-        object_release(file_obj);
 
     return rc;
 }
 
 static int
-_cl5WriteOperation(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local)
+_cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local)
 {
-    return _cl5WriteOperationTxn(replName, replGen, op, local, NULL);
+    return _cl5WriteOperationTxn(cldb, op, local, NULL);
 }
 
 static int
-_cl5GetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *txnid)
+_cl5GetFirstEntry (cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid)
 {
     int rc;
     DBC *cursor = NULL;
     DBT key = {0}, data = {0};
     CL5Iterator *it;
-    CL5DBFile *file;
 
-    PR_ASSERT(obj && entry && iterator);
+    PR_ASSERT(entry && iterator);
 
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
     /* create cursor */
-    rc = file->db->cursor(file->db, txnid, &cursor, 0);
+    rc = cldb->db->cursor(cldb->db, txnid, &cursor, 0);
     if (rc != 0) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5GetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
@@ -4949,8 +4112,7 @@ _cl5GetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *txnid)
 
         it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
         it->cursor = cursor;
-        object_acquire(obj);
-        it->file = obj;
+        it->file = cldb;
         *(CL5Iterator **)iterator = it;
 
         return CL5_SUCCESS;
@@ -5060,7 +4222,7 @@ _cl5CurrentDeleteEntry(void *iterator)
 {
     int rc;
     CL5Iterator *it;
-    CL5DBFile *file;
+    cldb_Handle *cldb;
 
     PR_ASSERT(iterator);
 
@@ -5070,8 +4232,8 @@ _cl5CurrentDeleteEntry(void *iterator)
 
     if (rc == 0) {
         /* decrement entry count */
-        file = (CL5DBFile *)object_get_data(it->file);
-        PR_AtomicDecrement(&file->entryCount);
+        cldb = it->file;
+        PR_AtomicDecrement (&cldb->entryCount);
         return CL5_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
@@ -5093,22 +4255,14 @@ _cl5IsValidIterator(const CL5Iterator *iterator)
 }
 
 static int
-_cl5GetOperation(Object *replica, slapi_operation_parameters *op)
+_cl5GetOperation (cldb_Handle *cldb, slapi_operation_parameters *op)
 {
     int rc;
     DBT key = {0}, data = {0};
-    CL5DBFile *file;
     CL5Entry entry;
-    Object *obj = NULL;
     char csnStr[CSN_STRSIZE];
 
-    rc = _cl5GetDBFile(replica, &obj);
-    if (rc != CL5_SUCCESS || !obj) {
-        goto done;
-    }
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
+    if (NULL == cldb) goto done;
 
     /* construct the key */
     key.data = csn_as_string(op->csn, PR_FALSE, csnStr);
@@ -5116,7 +4270,7 @@ _cl5GetOperation(Object *replica, slapi_operation_parameters *op)
 
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL/*txn*/, &key, &data, 0);
     switch (rc) {
     case 0:
         entry.op = op;
